function code()
	if (updatecode == 1) then
		features = {}
		featureindex = {}
		firstwords = {}
		visualfeatures = {}
		local existing = {}
		
		featureindex["level"] = {}
		featureindex["stop"] = {}
		table.insert(features, {"level","is",{"stop"}})
		table.insert(featureindex["level"], {"level","is",{"stop"}})
		table.insert(featureindex["stop"], {"level","is",{"stop"}})
		
		if ruledebug then
			MF_alert("redoing rules...")
		end
	
		if (#codeunits > 0) then
			if ruledebug then
				MF_alert("rulewords:" .. tostring(#codeunits))
			end
			for iid,unitid in ipairs(codeunits) do
				local unit = mmf.newObject(unitid)
				local x,y = unit.values[XPOS],unit.values[YPOS]
				local unittype = unit.values[TYPE]
				local name = unit.strings[NAME]
				local ox,oy = 0,0
				
				unit.direction = 0
				
				for i=1,2 do
					local drs = dirs[i+2]
					local start = false
					ox = drs[1]
					oy = drs[2]
					local steps = 0
					local limit = 0
					local valid = 0
					
					while (start == false) do
						local hm = codecheck(unitid,ox * steps,oy * steps)
						steps = steps + 1
						
						if (hm > 0) then
							local tile = mmf.newObject(hm)

							if (tile.values[TYPE] == 1) then
								limit = limit - 1
							else
								limit = limit + 1
							end
							
							if (limit == 1) then
								valid = hm
							end
							
							if (limit < 0) or (limit > 1) then
								start = true
							end
						else
							start = true
						end
					end
					
					if (valid > 0) then
						local vid = tostring(i) .. "_" .. tostring(valid)
						
						if (existing[vid] == nil) then
							table.insert(firstwords, {valid, i})
							existing[vid] = 1
							
							local validunit = mmf.newObject(valid)
						end
					end
				end
			end
			
			docode()
			grouprules()
			updatecode = 0
			ruledebug = false
		end
	end
end

function docode()
	if (#firstwords > 0) then
		if ruledebug then
			print("Potential first words for rules: " .. tostring(#firstwords))
		end
		for k,unitdata in ipairs(firstwords) do
			local unit = mmf.newObject(unitdata[1])
			local x,y = unit.values[XPOS],unit.values[YPOS]
			local ox,oy = 0,0
			local name = unit.strings[NAME]
			--print("first word: " .. name .. ", dir: " .. tostring(unitdata[2]))
			
			local dir = unitdata[2]
			local drs = dirs[dir]
			ox = drs[1]
			oy = drs[2]
			
			local limit = 0
			local steps = 0
			local done = false
			local sentence = {}
			
			while (done == false) do
				local hm = codecheck(unitdata[1],ox * steps,oy * steps)
				steps = steps + 1
				
				if (hm > 0) then
					local tile = mmf.newObject(hm)
					local tilename = tile.strings[NAME]
					local tiletype = tile.values[TYPE]
					
					if (tiletype == 1) then
						limit = limit - 1
					else
						limit = limit + 1
					end
					
					if (limit >= 0) and (limit <= 1) then
						table.insert(sentence, {tilename, tiletype, hm, tiletype})
					else
						done = true
					end
				else
					local latest = sentence[#sentence]
					if (latest[2] == 1) then
						table.remove(sentence, #sentence)
					end
					done = true
				end
			end
			
			if ruledebug then
				print("Potential sentences: " .. tostring(#sentence))
			end
			
			if (#sentence > 2) then
				local phase = 0
				local absphase = 0
				limit = 0
				local groups = {}
				local visuals = {}
				local ops = {}
				local groupid = 1
				local visualid = 1
				groups[groupid] = {}
				visuals[visualid] = {}
				
				for a,b in ipairs(sentence) do
					if (b[2] ~= 1) then
						local thisgroup = groups[groupid]
						local thisvis = visuals[visualid]
						table.insert(thisgroup, b[1])
						table.insert(thisvis, {b[3], b[4]})
						limit = limit + 1
					end
					
					if (b[2] == 1) then
						if (b[1] ~= "and") then
							table.insert(ops, b[1])
							
							groupid = groupid + 1
							groups[groupid] = {}
						end
						limit = limit - 1
						
						local thisvis = visuals[visualid]
						table.insert(thisvis, {b[3], b[4]})
						visualid = visualid + 1
						visuals[visualid] = {}
					end
					
					if (b[1] == "is") and (phase ~= 1) then
						phase = 1
						
						if (absphase <= 1) then
							absphase = absphase + 1
						else
							absphase = absphase + 2
						end
					end
					
					if (b[1] == "has") and (phase ~= 2) then
						phase = 2
						absphase = absphase + 1
					end
					
					if (b[1] == "on") and (phase ~= 3) then
						phase = 3
						absphase = absphase + 1
					end
					
					if (b[1] == "make") and (phase ~= 4) then
						phase = 4
						absphase = absphase + 1
					end
					
					if (b[1] == "follow") and (phase ~= 5) then
						phase = 5
						absphase = absphase + 1
					end
					
					if (b[1] == "eat") and (phase ~= 6) then
						phase = 6
						absphase = absphase + 1
					end
					
					if (absphase > 3) then
						local previous = sentence[a-1]
						table.insert(firstwords, {previous[3], dir})
						table.remove(ops, #ops)
						table.insert(ops, "end")
						break
					end 
					
					if (limit < 0) or (limit > 1) then
						phase = 99
						limit = 99
						
						if (limit < 0) then
							table.remove(ops, #ops)
							table.remove(visuals, #visuals)
						elseif (limit > 1) then
							local thisgroup = groups[groupid]
							local thisvis = visuals[visualid]
							table.remove(thisgroup, #thisgroup)
							table.remove(thisvis, #thisvis)
							
							if (#thisgroup == 0) then
								table.remove(groups, groupid)
							end
							
							if (#thisvis == 0) then
								table.remove(visuals, visualid)
							end
						end
						
						table.insert(ops, "end")
						break
					end
				end
				
				if ruledebug then
					print("Potential rules: " .. tostring(#groups))
				end
				
				if (#groups > 0) then
					for a,group in ipairs(groups) do
						local style = ops[a]
						local prevstyle = ""
						local nextstyle = ""
						
						if (ops[a-1] ~= nil) then
							prevstyle = ops[a-1]
						end
						
						if (ops[a+1] ~= nil) then
							nextstyle = ops[a+1]
						end
						
						if (style ~= "on") and (prevstyle ~= "on") and (nextstyle ~= "on") then
							for c,d in ipairs(group) do
								local nextgroup = groups[a+1]
								
								if (nextgroup ~= nil) then
									for e,f in ipairs(nextgroup) do
										addoption({d,style,{f}})
									end
								end
							end
						elseif (style == "on") then
							local nextgroup = groups[a+1]
							local nextgroup2 = groups[a+2]
							local prevgroup = groups[a-1]
							local style2 = ops[a+1]
							local style3 = ops[a-1]

							if (nextgroup ~= nil) and (nextgroup2 ~= nil) and (style2 ~= nil) then
								for c,d in ipairs(group) do
									for e,f in ipairs(nextgroup2) do
										addoption({d,"on",nextgroup,style2,f})
									end
								end
							end
							
							if (nextgroup ~= nil) and (prevgroup ~= nil) and (style3 ~= nil) then
								for c,d in ipairs(prevgroup) do
									for e,f in ipairs(group) do
										addoption({d,"on",nextgroup,style3,f})
									end
								end
							end
						end
					end
					
					-- TÄMÄ ON KESKEN! Vaatii miettimistä - miten saadaan tekstin efektistä yhtä hyvin toimiva kuin lauseenlöytämisestä (ilman liiallista raskautta)?
					local vvalid = false
					
					for d,c in ipairs(visuals) do
						for e,f in ipairs(c) do
							local this = mmf.newObject(f[1])
							
							if (this.values[TYPE] == 0) and (d == 1) then
								vvalid = true
							end
							
							if vvalid then
								if (this.values[TYPE] ~= 2) or ((this.values[TYPE] == 2) and (d > 1)) then
									this.direction = 1
								end
							end
						end
					end
				end
			end
		end
	end
end

function codecheck(unitid,ox,oy)
	local unit = mmf.newObject(unitid)
	local x,y = unit.values[XPOS],unit.values[YPOS]
	local result = 0
	for i,b in ipairs(codeunits) do
		local v = mmf.newObject(b)
		local ux,uy = v.values[XPOS],v.values[YPOS]
		
		if (ux == x + ox) and (uy == y + oy) then
			result = b
		end
	end
	
	return result
end

function addoption(option,visual_)
	local visual = true
	
	if (visual_ ~= nil) then
		visual = visual_
	end
	
	if (#option == 3) or (#option == 5) then
		table.insert(features, option)
		local b = option[1]
		local d = option[#option]
		local o3 = option[3]
		local verb = option[4]
		
		if (#option == 3) then
			d = option[#option][1]
			verb = option[2]
		end
	
		if (featureindex[d] == nil) then
			featureindex[d] = {}
		end
		
		if (featureindex[b] == nil) then
			featureindex[b] = {}
		end
		
		if (featureindex[verb] == nil) then
			featureindex[verb] = {}
		end
		
		table.insert(featureindex[d], option)
		
		table.insert(featureindex[verb], option)
		
		if (d ~= b) then
			table.insert(featureindex[b], option)
		end
		
		if visual then
			table.insert(visualfeatures, option)
		end
		
		if (#option == 5) then
			local ongroup = false
					
			for e,f in ipairs(option[3]) do
				if (f == "group") then
					ongroup = true
				end
			end
		end
		
		if (#option == 5) then
			local onall = false
					
			for e,f in ipairs(option[3]) do
				if (f == "all") then
					onall = true
				end
			end
			
			if onall then
				local newon = {}
						
				for e,f in ipairs(materials) do
					if (f ~= "empty") and (f ~= "all") and (f ~= "group") then
						table.insert(newon, f)
					end
				end
				
				o3 = newon
				
				if (b ~= "all") then
					addoption({b,option[2],o3,option[4],d},false)
				end
			end
		end
		
		if (d == "all") then
			if (#option == 3) then
				if (option[2] ~= "is") then 
					for i,v in ipairs(materials) do
						if (v ~= "empty") and (v ~= "all") and (v ~= "level") and (v ~= "group") then
							addoption({b,option[2],{v}},false)
						end
					end
				end
			elseif (#option == 5) then
				if (option[4] ~= "is") then 
					for i,v in ipairs(materials) do
						if (v ~= "empty") and (v ~= "all") and (v ~= "level") and (v ~= "group") then
							addoption({b,option[2],o3,option[4],v},false)
						end
					end
				end
			end
		end

		if (b == "all") then
			if (#option == 3) then
				for i,v in ipairs(materials) do
					if (v ~= "empty") and (v ~= "all") and (v ~= "level") and (v ~= "group") then
						addoption({v,option[2],{d}},false)
					end
				end
			elseif (#option == 5) then
				for i,v in ipairs(materials) do
					if (v ~= "empty") and (v ~= "all") and (v ~= "level") and (v ~= "group") then
						addoption({v,option[2],o3,option[4],d},false)
					end
				end
			end
		end
	end
end

function grouprules()
	local isgroup = {}
	local groupis = {}
	local groups = findgroup()
	
	if (featureindex["group"] ~= nil) then
		for i,rule in ipairs(featureindex["group"]) do
			if (rule[1] == "group") then
				table.insert(groupis, rule)
			end
				
			if (#rule == 3) then
				for a,b in ipairs(rule[3]) do
					if (b == "group") and (rule[1] ~= "group") then
						table.insert(isgroup, rule)
					end
				end
			elseif (#rule == 5) then
				if (rule[5] == "group") and (rule[1] ~= "all") and (rule[1] ~= "group") then
					table.insert(isgroup, rule)
				end
			end
		end
	end
	
	local ends = {}
	local starts = {}
	
	if (#groupis > 0) then
		for i,v in ipairs(groupis) do
			local d = ""
			local verb = ""
			local c = {}
			
			if (#v == 3) then
				d = v[3][1]
				verb = v[2]
				
				table.insert(ends, {d,verb})
			elseif (#v == 5) then
				d = v[5]
				c = v[3]
				verb = v[4]
				
				table.insert(ends, {d,verb,c})
				--MF_alert(v[1] .. " " .. v[2] .. " " .. v[4] .. " " ..v[5])
			end
		end
	end			
	
	if (#isgroup > 0) then
		for i,v in ipairs(isgroup) do
			local b = v[1]
			local c = {}
			local verb = ""
			
			if (#v == 3) then
				verb = v[2]
				table.insert(starts, {b,verb})
			elseif (#v == 5) then
				c = v[3]
				verb = v[4]
				
				table.insert(starts, {b,verb,c})
			end
		end
	end
	
	for i,v in ipairs(starts) do
		if (v[2] ~= "is") then
			local conditions = {}
			if (v[3] ~= nil) then
				for a,b in ipairs(v[3]) do
					table.insert(conditions, b)
				end
			end
			
			for a,b in ipairs(starts) do
				if (b[3] == nil) and (b[2] == "is") then
					if (#conditions == 0) then
						addoption({v[1],v[2],{b[1]}},false)
					else
						addoption({v[1],"on",conditions,v[2],{b[1]}},false)
					end
				elseif (b[3] ~= nil) and (b[2] == "is") then
					for c,d in ipairs(b[3]) do
						table.insert(conditions, d)
					end
					
					addoption({v[1],"on",conditions,v[2],{b[1]}},false)
				end
			end
		end
		
		for a,b in ipairs(ends) do
			if (v[3] == nil) and (b[3] == nil) then
				if (v[2] == "is") then
					addoption({v[1],b[2],{b[1]}},false)
				end
			end
			
			if (v[3] ~= nil) or (b[3] ~= nil) then
				local conditions = {}
				local ba,va = 0,0
				
				if (v[3] ~= nil) then
					va = #v[3]
					for c,d in ipairs(v[3]) do
						table.insert(conditions, d)
					end
				end
				
				if (b[3] ~= nil) then
					ba = #b[3]
					for c,d in ipairs(b[3]) do
						table.insert(conditions, d)
					end
				end
				
				if (#conditions > 0) then
					for g,h in ipairs(conditions) do
						--MF_alert(tostring(i) .. "-" .. tostring(a) .. ", " .. tostring(g) .. ": " .. h .. " (" .. tostring(va) .. ", " .. tostring(ba) .. ")")
					end
				end
				
				if (v[2] == "is") then
					addoption({v[1],"on",conditions,b[2],b[1]},false)
				end
			end
		end
	end
	
	if (#features > 0) and (#groups > 0) then
		for i,rule in ipairs(features) do
			if (#rule == 5) then
				local thisrule = rule[3]
				local limit = #thisrule
				local delthese = {}

				for a=1,limit do
					local b = thisrule[a]
					
					if (b == "group") then
						if (#groups > 0) then
							for c,d in ipairs(groups) do
								if (d[1] ~= "group") then
									table.insert(rule[3], d[1])
									
									if (d[2] ~= nil) then
										for e,f in ipairs(d[2]) do
											if (f ~= "group") then
												table.insert(rule[3], f)
											end
										end
									end
								end
							end
						end
						
						table.insert(delthese, a)
					end
				end
			
				if (#delthese > 0) then
					local offset = 0
					for a,b in ipairs(delthese) do
						local id = b + offset
						table.remove(rule[3], id)
						offset = offset - 1
					end
				end
				
				--[[
				if (#rule[3] > 0) then
					for a,b in ipairs(rule[3]) do
						MF_alert(tostring(i) .. ", " .. tostring(a) .. ": " .. b)
					end
				end
				]]--
			end
		end
	end					
end